--- a/drivers/tty/serial/8250.c	2012-04-02 18:53:31.000000000 +0200
+++ b/drivers/tty/serial/8250.c	2012-04-03 00:46:50.273096994 +0200
@@ -2826,7 +2833,11 @@
 	struct uart_8250_port *up =
 		container_of(port, struct uart_8250_port, port);
 
+#ifdef CONFIG_AR7
+	wait_for_xmitr(up, BOTH_EMPTY);
+#else
 	wait_for_xmitr(up, UART_LSR_THRE);
+#endif
 	serial_out(up, UART_TX, ch);
 }
 
